import React, { useEffect, useState } from "react";
import { Button, IconButton, TextField, Tooltip } from "@mui/material";
import axios from "axios";
import { RiSearchLine } from "react-icons/ri";
import { getRoleFromUrl } from "../../../../utils/getRoleFromUrl";
import {
  LOADING_END,
  LOADING_START,
  OPEN_MODAL,
} from "../../../../lib/redux/slices/appSlice";
import { useDispatch } from "react-redux";
import { Grid } from "../../../../components/grid/Grid";
import ResponsiveTable from "../../../../components/responsive-table/ResponsiveTable";
import InventoryIcon from "@mui/icons-material/Inventory";
import { ProvinceManageTradesSetPercents } from "../province-manage-trades-set-percents/ProvinceManageTradesSetPercents";

export const ProvinceManageTrades = () => {
  const handleTextChange = (event) => {
    setTextValue(event.target.value);
  };

  const dispatch = useDispatch();

  const [data, setData] = useState([]);
  const [totalRows, setTotalRows] = useState(0);
  const [perPage, setPerPage] = useState(10);
  const [textValue, setTextValue] = useState("");
  const [page, setPage] = useState(1);
  const [tableData, setTableData] = useState([]);

  const fetchApiData = async (page) => {
    let response;
    dispatch(LOADING_START());
    response = await axios.get(
      `market-kill-houses/?search=filter&value=${textValue}&role=${getRoleFromUrl()}&page=${page}&page_size=${perPage}`
    );
    dispatch(LOADING_END());
    setData(response.data.results);
    setTotalRows(response.data.count);
  };

  const handlePageChange = (page) => {
    fetchApiData(page);
    setPage(page);
  };

  const handlePerRowsChange = (perRows) => {
    setPerPage(perRows);
    setPage(1);
  };

  const updateTable = () => {
    fetchApiData(page !== 0 ? page : 1);
  };

  useEffect(() => {
    const d = data?.map((item, i) => {
      return [
        page === 1 ? i + 1 : i + perPage * (page - 1) + 1,
        item?.name,
        `${item?.fullname} (${item?.mobile})`,
        item?.killer ? "کشتارکن" : "کشتارگاه",
        item?.marketBuying ? "دارد" : "ندارد",
        item?.totalKillCapacity?.toLocaleString(),
        item?.totalKillCapacityPercent?.toLocaleString(),
        `%${item?.marketCapacityPercent}`,
        item?.marketLightCapacity ? "دارد" : "ندارد",
        item?.marketLightCapacity
          ? `%${item?.marketLightCapacityPercent}`
          : "-",
        <Tooltip title={"تعیین درصد"} placement="left-start" key={i}>
          <IconButton
            aria-label="delete"
            color="primary"
            onClick={() => {
              dispatch(
                OPEN_MODAL({
                  title: "تعیین درصد",
                  content: (
                    <ProvinceManageTradesSetPercents
                      updateTable={updateTable}
                      item={item}
                    />
                  ),
                })
              );
            }}
          >
            <InventoryIcon />
          </IconButton>
        </Tooltip>,
      ];
    });

    setTableData(d);
  }, [data]);

  useEffect(() => {
    fetchApiData(1);
  }, [dispatch, perPage]);

  const handleSubmit = async (event) => {
    event.preventDefault();
    dispatch(LOADING_START());

    try {
      const response = await axios.get(
        `market-kill-houses/?role=${getRoleFromUrl()}&search=filter&value=${textValue}&page=${1}&page_size=${perPage}`
      );
      setData(response.data.results);
      setTotalRows(response.data.count);
      dispatch(LOADING_END());
    } catch (error) {
      console.error("Error fetching data:", error);
    }
  };

  return (
    <Grid container xs={12} justifyContent="center" alignItems="center" gap={2}>
      <Grid
        container
        xs={12}
        justifyContent="start"
        alignItems="center"
        gap={2}
      >
        <Grid>
          <form onSubmit={handleSubmit}>
            <TextField
              id="outlined-basic"
              size="small"
              label="جستجو"
              variant="outlined"
              style={{ width: 250 }}
              onChange={handleTextChange}
            />
            <Button
              // disabled={!textValue}
              type="submit"
              onClick={handleSubmit}
              endIcon={<RiSearchLine />}
            >
              جستجو
            </Button>
          </form>
        </Grid>
      </Grid>

      <ResponsiveTable
        data={tableData}
        columns={[
          "ردیف",
          "نام",
          "نام مالک",
          "نوع واحد",
          "اجازه خرید",
          "سقف کشتار",
          "درصد از سقف کشتار",
          "درصد از کل خرید",
          "اولویت خرید سبک",
          " خرید سبک",
          "عملیات",
        ]}
        handlePageChange={handlePageChange}
        totalRows={totalRows}
        page={page}
        perPage={perPage}
        handlePerRowsChange={handlePerRowsChange}
        title="کشتارگاه ها"
      />
    </Grid>
  );
};
